
require 'sketchup.rb'
require "extensions.rb"


$uStrings = LanguageHandler.new("quarr_jsalign")
quarr_jsalign_Extension = SketchupExtension.new $uStrings.GetString("quarr_jsalign"), "quarr_jsalign.rb"
quarr_jsalign_Extension.description=$uStrings.GetString("Quarr JSAlign")
quarr_jsalign_Extension.name= "quarr_jsalign"

Sketchup.register_extension quarr_jsalign_Extension, true


def exec_on_autoload
  puts("quarr_jsalign loaded.")
end



if( not $quarr_jsalign_menu_loaded )

##################################################################################################  
#_quarr_jsalign_plugins_menu = UI.menu("Plugins").add_submenu("Q JSALIGN")
##################################################################################################  

##################################################################################################  	
gp_quarr_jsalign_tb = UI::Toolbar.new("Q JSALIGN")
 ##################################################################################################    
   

   
   
      
####################################################   MENUS    RED  #######################################

cmd = UI::Command.new("Align to Red - Min") { jsAlign_red_min  }
cmd.small_icon = "CD_ICONS/ALIGN/armin_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/armin_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  

cmd = UI::Command.new("Align to Red - Centre") { jsAlign_red_centre  }
cmd.small_icon = "CD_ICONS/ALIGN/arcen_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/arcen_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  

		
cmd = UI::Command.new("Align to Red - Max")  { jsAlign_red_max  }
cmd.small_icon = "CD_ICONS/ALIGN/armax_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/armax_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  



####################################################   MENUS    GREEN  #######################################

cmd = UI::Command.new("Align to Green - Min") { jsAlign_green_min  }
cmd.small_icon = "CD_ICONS/ALIGN/agmin_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/agmin_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  

cmd = UI::Command.new("Align to Green - Centre") { jsAlign_green_centre  }
cmd.small_icon = "CD_ICONS/ALIGN/agcen_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/agcen_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  

		
cmd = UI::Command.new("Align to Green - Max")  { jsAlign_green_max  }
cmd.small_icon = "CD_ICONS/ALIGN/agmax_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/agmax_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  

   
   
  ####################################################   MENUS    BLUE  #######################################

cmd = UI::Command.new("Align to Blue - Min") { jsAlign_blue_min  }
cmd.small_icon = "CD_ICONS/ALIGN/abmin_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/abmin_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  

cmd = UI::Command.new("Align to Blue - Centre") { jsAlign_blue_centre  }
cmd.small_icon = "CD_ICONS/ALIGN/abcen_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/abcen_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################  

		
cmd = UI::Command.new("Align to Blue - Max")  { jsAlign_blue_max  }
cmd.small_icon = "CD_ICONS/ALIGN/abmax_16.png"
cmd.large_icon = "CD_ICONS/ALIGN/abmax_24.png"
gp_quarr_jsalign_tb.add_item(cmd)

##################################################################################################   
   
   
   
   
   
   
##############################################################################################################################   
   

class Sketchup::Selection 
def vertices 
	selverts = []; 
	self.each {|e| 
		selverts.push e.vertices if (e.respond_to?(:vertices)); 
	} 
	return selverts.flatten.uniq; 
end ;  # method vertices
end ;  # class Sketchup::Selection 


############################################################################################################   @@@@@@@@@@@@@@@@@@@@@@@         RED MAX


def jsAlign_red_max 
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
			
	
############################################################################################
		
#	base == "Max"
		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
#		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
#		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
#			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
#			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"RED"
			dist = Geom::Point3d.new [basepoint.x-point.x, 0, 0];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"RED"
			dist = Geom::Point3d.new [basepoint.x-point.x, 0, 0];
############################################################################################

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	
############################################################################################    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@   RED CENTRE





def jsAlign_red_centre
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
			
	
############################################################################################
		
#	base == "Max"
#		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
#		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
#			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
#			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"RED"
			dist = Geom::Point3d.new [basepoint.x-point.x, 0, 0];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"RED"
			dist = Geom::Point3d.new [basepoint.x-point.x, 0, 0];
############################################################################################

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	

############################################################################################    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@   RED MIN




def jsAlign_red_min
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
			
	
############################################################################################
		
#	base == "Max"
#		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
#		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
#			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
#			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"RED"
			dist = Geom::Point3d.new [basepoint.x-point.x, 0, 0];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"RED"
			dist = Geom::Point3d.new [basepoint.x-point.x, 0, 0];
############################################################################################

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	













############################################################################################################   @@@@@@@@@@@@@@@@@@@@@@@         GREEN MAX


def jsAlign_green_max
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
			
	
############################################################################################
		
#	base == "Max"
		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
#		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
#		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
#			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
#			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"GREEN"
		 dist = Geom::Point3d.new [0, basepoint.y-point.y, 0];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"GREEN"
			dist = Geom::Point3d.new [0, basepoint.y-point.y, 0];
############################################################################################
					

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	


############################################################################################    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@   GREEN CENTRE










def jsAlign_green_centre
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
			
	
############################################################################################
		
#	base == "Max"
#		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
#		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
#			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
#			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"GREEN"
		 dist = Geom::Point3d.new [0, basepoint.y-point.y, 0];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"GREEN"
			dist = Geom::Point3d.new [0, basepoint.y-point.y, 0];
############################################################################################
					

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	



############################################################################################    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@   GREEN MIN






def jsAlign_green_min
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
			
	
############################################################################################
		
#	base == "Max"
#		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
#		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
#			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
#			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"GREEN"
		 dist = Geom::Point3d.new [0, basepoint.y-point.y, 0];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"GREEN"
			dist = Geom::Point3d.new [0, basepoint.y-point.y, 0];
############################################################################################
					

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	














############################################################################################################   @@@@@@@@@@@@@@@@@@@@@@@         BLUE MAX


def jsAlign_blue_max
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
		
############################################################################################

#	base == "Max"
		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
#		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
#		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
#			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
#			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"BLUE"
			dist = Geom::Point3d.new [0, 0, basepoint.z-point.z];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"BLUE"
			dist = Geom::Point3d.new [0, 0, basepoint.z-point.z];
############################################################################################
					

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	



############################################################################################    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@   BLUE CENTRE










def jsAlign_blue_centre
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
		
############################################################################################

#	base == "Max"
#		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
#		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
#			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
#			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"BLUE"
			dist = Geom::Point3d.new [0, 0, basepoint.z-point.z];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"BLUE"
			dist = Geom::Point3d.new [0, 0, basepoint.z-point.z];
############################################################################################
					

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	





############################################################################################    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@   BLUE MIN






def jsAlign_blue_min
	model = Sketchup.active_model
	entities = model.active_entities
	sel = model.selection
	if sel.empty?
     		UI.beep
     		UI.messagebox("Nothing Selected!")
     		return nil
  	end#if
	
	
  	### Get all edges in selection
	edges=[]
	for e in sel
  		if e.typename=="Edge" and e.valid?
    			edges.push(e)
  		end#if
	end#for
  	
  	
	
  	### Align
  		
	selverts = Sketchup.active_model.selection.vertices; 
	bb = Geom::BoundingBox.new;
	Sketchup.active_model.selection.each {|e| bb.add(e.bounds); } 
		
############################################################################################

#	base == "Max"
#		basepoint = Geom::Point3d.new (bb.max);
#	base == "Center"
#		basepoint = Geom::Point3d.new (bb.center);
#	base == "Min"
		basepoint = Geom::Point3d.new (bb.min);
	
	distances = []; 
	groupstomove = [];
	groupdistances = [];	
	
############################################################################################

		# Aligning groups
		Sketchup.active_model.selection.each {|e|
		if (e.kind_of? Sketchup::Group) or (e.kind_of? Sketchup::ComponentInstance) 
		groupstomove.push e
		
############################################################################################
		
#		base == "Max"
#			point = Geom::Point3d.new (e.bounds.max);
#		base == "Center"
#			point = Geom::Point3d.new (e.bounds.center);
#		base == "Min"
			point = Geom::Point3d.new (e.bounds.min);
			
############################################################################################
#		"BLUE"
			dist = Geom::Point3d.new [0, 0, basepoint.z-point.z];
############################################################################################

     	groupdistances.push dist;
	end #if 
	}
	
	Sketchup.active_model.active_entities.transform_by_vectors groupstomove, groupdistances;

	
	# Aligning edges
	selverts.each {|v| 
		point = Geom::Point3d.new [v.position.x, v.position.y, v.position.z];
		
############################################################################################
#		"BLUE"
			dist = Geom::Point3d.new [0, 0, basepoint.z-point.z];
############################################################################################
					

		distances.push dist; 
	}
	Sketchup.active_model.active_entities.transform_by_vectors selverts, distances;
end	


############################################################################################    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



$quarr_jsalign_menu_loaded = true
end
file_loaded("quarr_jsalign.rb")